//---------------------------------------------------------------------------
#ifndef SoundH
#define SoundH

#include <mmsystem.h>
#include "groupfile.h"
#include "RTSFile.h"

#define CHANNEL_MAIN 0
#define CHANNEL_RTS 1
#define CHANNEL_ANIM 2

typedef struct
{
    char *name;
    int len;
    WAVEFORMATEX format;
    void *data;
} Sound;

#define SOUNDCACHE_STEP 16
#define SOUND_CHANNELS 32

class SoundEngine
{
public:
    SoundEngine();
    virtual ~SoundEngine();
    virtual int Initialized();
    virtual void SetChannelType(int c,int t)=0;
    virtual int PlaySound(Sound *snd,int t,int pri,int loop)=0;
    virtual void StopSound(int c)=0;
    virtual void SoundMute(int mute)=0;
};

extern Sound* LoadSound(GroupFile *group,char *name);
extern Sound* LoadRTSSound(RTSFile *rts,int i);

//---------------------------------------------------------------------------
#endif
