#ifndef __TEXTURE_H__
#define __TEXTURE_H__

#include "Direct3D.h"

#define ALPHA_NONE 0
#define ALPHA_ONEBIT 1
#define ALPHA_FULL 2

class CTexture
{
	IDirectDrawSurface7* lpTexture;
	CDirect3D *D3D;
public:
    char *fn,*afn;
	CTexture(CDirect3D *d3d);
	~CTexture();
	int Create(int width,int height,int alpha=ALPHA_NONE,
		int hint=0,int mipMap=1);
    void LoadFromFile(char *filename);
    void LoadFromFileWithAlpha(char *filename,char *alphaname);
    void LoadFromMemoryTexture(Texture *tex);
    void UpdateMemoryTexture(Texture *tex);
    void Reload(CDirect3D *d3d);
	void *Lock();
	void Unlock();
    IDirectDrawSurface7* GetTexture() { return lpTexture; }
    void GenerateMipMap();
    char* GetName() { return fn; }
};

#endif
